package com.liang.dao;

import com.liang.entity.FeeManagemant;
import com.liang.entity.PrjProject;
import com.liang.entity.PrjProjects;
import com.liang.entity.StaBudgetapproval;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * 项目(PrjProject)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-09 20:06:47
 */
public interface PrjProjectDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjProject queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjProject 查询条件
     * @param pageable   分页对象
     * @return 对象列表
     */
    List<PrjProject> queryAllByLimit(PrjProject prjProject, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjProject 查询条件
     * @return 总行数
     */
    long count(PrjProject prjProject);

    /**
     * 新增数据
     *
     * @param prjProject 实例对象
     * @return 影响行数
     */
    int insert(PrjProject prjProject);

    /**
     * 新增数据（基本信息）
     *
     * @param prjProject 实例对象
     * @return 影响行数
     */
    int insertNormal(PrjProject prjProject);

    /**
     * 新增数据（基本信息）
     *
     * @param prjProject 实例对象
     * @return 影响行数
     */
    int tjrevokeApprove(PrjProject prjProject);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjProject> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjProject> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjProject> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjProject> entities);

    /**
     * 修改数据
     *
     * @param prjProject 实例对象
     * @return 影响行数
     */
    int update(PrjProject prjProject);

    /**
     * 修改数据(基本信息)
     *
     * @param prjProject 实例对象
     * @return 影响行数
     */
    int updateNormal(PrjProject prjProject);

    /**
     * 更新填写说明
     *
     * @return
     */
    int updateTXSM(String txsm, Integer id);

    /**
     * 更新研究内容及考核指标
     *
     * @return
     */
    int updateContent(String yjnrjkhzb, Integer id);

    /**
     * 更新有关问题说明
     *
     * @return
     */
    int updateYGWTSM(String ygwtsm, Integer id);

    /**
     * 更新附件
     *
     * @return
     */
    int updateFJ(String fj, Integer id);

    /**
     * 修改审批状态
     *
     * @param project 实例对象
     * @return 实例对象
     */
    int updateSpzt(PrjProject project);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取项目
     *
     * @return
     */
    List<PrjProject> getProjectList(Map map);

    /**
     * 获取项目
     *
     * @return
     */
    List<PrjProject> getNdysProjectList(Map map);

    List<PrjProject> getByjProjectList(Map map);

    /**
     * 批量删除项目任务书
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 获取项目任务书
     *
     * @return
     */
    List<PrjProject> getRwsList(Map map);

    /**
     * 获取费用管理列表
     *
     * @return
     */
    List<FeeManagemant> getFyglList(Map map);


    List<PrjProject> getErpBh(String erpbh);

    FeeManagemant getSqje(String erpbh);


    void updateSFXG(Integer xmid);


    /**
     * 项目转移
     */
    int updateZy(PrjProjects prjProjects);
}
